volatile uint8_t PK_Last = 0;
uint8_t base_speed = 170; // Good base speed to operate in delay region
uint8_t motor_speed1 = 0;
uint8_t motor_speed0 = 0;
volatile uint16_t motor_delay0 = 2200;
volatile uint16_t motor_delay1 = 2200; // Initialize to slow speed
volatile uint16_t last_time0 = 0;
volatile uint16_t last_time1 = 0;
const uint16_t set_delay = 1600;
uint8_t corr_val0 = 0;
uint8_t corr_val1 = 0;
const float Kp = 2;  // Kp is actually 0.5 



ISR(PCINT2_vect)
{
  // Major assistance with this code from Professor Gary Hill
  float curr_time = micros(); // Time stamp 
  uint8_t PK = PINK;  // Read Port K at Current Time
  PK &= ~(0xFC); // Clear Irrelevant Bits Just to be sure
  uint8_t PKC = PK;   // Make Copy of Port K For Shifting
  uint8_t CHG = PK_Last ^ PKC;  // Find out what pin changed
    for(int i = 0; i<6; i++) {
      if(CHG&0x01){ // Pin i has changed
        if(PKC&0x01){  // Pin i has risen
          if(i == 0){motor_delay0 = curr_time - last_time0; last_time0 = curr_time; // Time since last time pin i changed
          if(motor_delay0 >= 2100){motor_delay0 = 2100;}
          if(motor_delay0 <= 1500){motor_delay0 = 1500;}}
          if(i == 1){motor_delay1 = curr_time - last_time1; last_time1 = curr_time; // Time since last time pin i changed
          if(motor_delay1 >= 2200){motor_delay1 = 2200;}  // Limit Delay when starting up
          if(motor_delay1 <= 1300){motor_delay1 = 1300;}}
          if(i == 2){motor_delay2 = curr_time - last_time2; last_time2 = curr_time; // Time since last time pin i changed
          if(motor_delay2 >= 2200){motor_delay2 = 2200;}  // Limit Delay when starting up
          if(motor_delay2 <= 1300){motor_delay2 = 1300;}}
          if(i == 3){motor_delay3 = curr_time - last_time3; last_time3 = curr_time; // Time since last time pin i changed
          if(motor_delay3 >= 2200){motor_delay3 = 2200;}  // Limit Delay when starting up
          if(motor_delay3 <= 1300){motor_delay3 = 1300;}}
          if(i == 4){motor_delay4 = curr_time - last_time4; last_time4 = curr_time; // Time since last time pin i changed
          if(motor_delay4 >= 2200){motor_delay4 = 2200;}  // Limit Delay when starting up
          if(motor_delay4 <= 1300){motor_delay4 = 1300;}}
          if(i == 5){motor_delay5 = curr_time - last_time5; last_time5 = curr_time; // Time since last time pin i changed
          if(motor_delay5 >= 2200){motor_delay5 = 2200;}  // Limit Delay when starting up
          if(motor_delay5 <= 1300){motor_delay5 = 1300;}}
        }
      }
      CHG = CHG >> 1;   // Shift Change for next iteration
      PKC = PKC >> 1;   // Shift Copy of Port K for next iteration
    }
    PK_Last = PK;   // Store last value of Port K
    speedController();
}

void speedController() {
  for(int i = 0; i<6; i++) {
    if(i == 0)
    {
      if(motor_delay0 >= set_delay){corr_val0 = (motor_delay0-set_delay)/Kp; motor_speed0 = base_speed + corr_val1;}
      else{corr_val0 = (set_delay-motor_delay0)/Kp; motor_speed0 = base_speed - corr_val0;}
      }
    if(i == 1)
    {
      if(motor_delay1 >= set_delay){corr_val1 = (motor_delay1-set_delay)/Kp; motor_speed1 = base_speed + corr_val1;}
      else{corr_val1 = (set_delay-motor_delay1)/Kp; motor_speed1 = base_speed - corr_val1;}
      }
    if(i == 2)
    {
      if(motor_delay2 >= set_delay){corr_val2 = (motor_delay2-set_delay)/Kp; motor_speed2 = base_speed + corr_val2;}
      else{corr_val2 = (set_delay-motor_delay2)/Kp; motor_speed2 = base_speed - corr_val2;}
      }
    if(i == 3)
    {
      if(motor_delay3 >= set_delay){corr_val3 = (motor_delay3-set_delay)/Kp; motor_speed3 = base_speed + corr_val3;}
      else{corr_val3 = (set_delay-motor_delay3)/Kp; motor_speed3 = base_speed - corr_val3;}
      }
    if(i == 4)
    {
      if(motor_delay4 >= set_delay){corr_val4 = (motor_delay4-set_delay)/Kp; motor_speed4 = base_speed + corr_val4;}
      else{corr_val4 = (set_delay-motor_delay4)/Kp; motor_speed4 = base_speed - corr_val4;}
      }
    if(i == 5)
    {
      if(motor_delay5 >= set_delay){corr_val5 = (motor_delay5-set_delay)/Kp; motor_speed5 = base_speed + corr_val1;}
      else{corr_val5 = (set_delay-motor_delay5)/Kp; motor_speed5 = base_speed - corr_val5;}
      }
  }
}

